<template>
  <main id="news">
    <div class="title-block">
      <h1>
        <strong>{{ $gettext('PeerTube news!') }}</strong>
      </h1>

      <div class="small-separator"></div>
    </div>

    <NewsSubscribe></NewsSubscribe>

    <div class="big-container color-container news-container">
      <div class="small-container">
        <h2 class="text-center">
          <strong>{{ $gettext('What\'s new?') }}</strong>
        </h2>

        <div class="small-separator mx-auto"></div>

        <MascotPointing class="d-none d-sm-inline"></MascotPointing>

        <NewsArticle v-for="article in articles" :key="article.id" :article="article" :overview="true"></NewsArticle>
      </div>
    </div>

    <div class="text-center mt-5">
      <router-link to="/news-archive" class="jpt-secondary-button jpt-link-button">
        {{ $gettext('See older news') }}
      </router-link>
    </div>
  </main>
</template>

<script>
  import { defineComponent } from 'vue'

  import { useGettext } from 'vue3-gettext'
  import { useHead } from '@vueuse/head'

  import NewsArticle from '../../components/news/NewsArticle.vue'
  import NewsSubscribe from '../../components/news/NewsSubscribe.vue'

  import newsMeta from '../../news/meta.json'

  import { buildHead } from '../../shared/head'
  import { buildArticles } from '../../shared/news'

  import MascotPointing from '../../svg/mascot/pointing.svg'

  // We need a dedicated component for fresh news to not load all news inside the same component
  export default defineComponent({
    components: {
      NewsArticle,
      NewsSubscribe,
      MascotPointing
    },

    setup () {
      const { $gettext } = useGettext()

      return useHead(buildHead({
        title: $gettext('PeerTube news'),
        url: import.meta.env.VITE_URL + '/news',
        description: $gettext('Discover the latest PeerTube news, the YouTube decentralized alternative developed by Framasoft.'),
      }))
    },

    data: function () {
      return {
        articles: []
      }
    },

    created () {
      this.getNews()
    },

    mounted () {
      const archivedIds = newsMeta.en.filter(n => n.isArchive)
                                     .map(o => '#' + o.id)

      if (window.location.hash && archivedIds.includes(window.location.hash)) {
        this.$router.push({ path: '/news-archive', hash: window.location.hash })
        return
      }
    },

    methods: {
      getNews () {
        const markdownFiles = this.getCurrentShortLocale() === 'fr'
          ? import.meta.glob('../../news/fr/*.md', { eager: true })
          : import.meta.glob('../../news/en/*.md', { eager: true })

        this.articles = buildArticles(markdownFiles)
      }
    }
  })
</script>

<style lang="scss" scoped>
  @import '../../scss/_variables.scss';
  @import '../../scss/_mixins.scss';
  @import '../../scss/bootstrap-mixins.scss';

  #news {
    .news-container {
      @include media-breakpoint-down(sm) {
        padding-inline-start: 0;
        padding-inline-end: 0;
      }
    }

    .small-container {
      position: relative;

      svg {
        position: absolute;
        max-width: 160px;
        right: 0;
        top: -50px;
        transform: rotateY(180deg);
        height: auto;
      }
    }
  }
</style>
